
;Warm boot application example

WARM    EQU     30H             ;First location of the four bytes in RAM.
WARM1   EQU     55H             ;First predetermined value.
WARM2   EQU     0AAH            ;Second predetermined value.
WARM3   EQU     33H             ;Third predetermined value.
WARM4   EQU     0CCH            ;Fourth predetermined value.
WARMBT  EQU     0               ;Warm boot status bit.

        ORG     0

START:  JMP     MAIN            ;Bypass interrupt vectors.

        ORG     26H

MAIN:   MOV     R0,#WARM        ;Pointer for first byte.
        CJNE    @R0,#WARM1,COLD ;Test first byte.
        INC     R0              ;Pointer for second byte.
        CJNE    @R0,#WARM2,COLD ;Test second byte.
        INC     R0              ;Pointer for third byte.
        CJNE    @R0,#WARM3,COLD ;Test third byte.
        INC     R0              ;Pointer for fourth byte.
        CJNE    @R0,#WARM4,COLD ;Test fourth byte.
        SETB    WARMBT          ;This is a warm start.
        JMP     INIT            ;Continue with rest of application.
COLD:   CLR     WARMBT          ;This is a cold boot.
        MOV     R0,#WARM        ;Pointer for first byte.
        MOV     @R0,#WARM1      ;Load the four bytes for future test.
        INC     R0              ;
        MOV     @R0,#WARM2      ;
        INC     R0              ;
        MOV     @R0,#WARM3      ;
        INC     R0              ;
        MOV     @R0,#WARM4      ;
INIT:                           ;Continue with the application.

        END
